export type { InstantiateParams } from './NativeWebassembly';
export type WebassemblyInstance<Exports extends object> = {
    readonly exports: Exports;
};
type WebAssemblyMemoryParams = {
    readonly initial: number;
};
export declare class Memory {
    readonly __initial: WebAssemblyMemoryParams['initial'] | undefined;
    constructor(params: WebAssemblyMemoryParams);
}
export type WebAssemblyEnv = {
    readonly memory?: Memory;
};
export type Imports = Record<string, Function>;
export type WebAssemblyImportObject = {
    readonly env?: WebAssemblyEnv;
    readonly imports: Imports;
};
export type WebassemblyInstantiateResult<Exports extends object> = {
    readonly instance: WebassemblyInstance<Exports>;
};
export declare function instantiate<Exports extends object>(bufferSource: Uint8Array | ArrayBuffer, importObject?: WebAssemblyImportObject | undefined): Promise<WebassemblyInstantiateResult<Exports>>;
//# sourceMappingURL=index.d.ts.map